(function() {
/**
 * @module dixim
 * @submodule xml
 * @class xml
 */
dixim.namespace('dixim.xml');

/**
 * @method escape
 * @static
 */
dixim.xml.escape = function(str) {
  return str.replace(/&/g, '&amp;').
             replace(/'/g, '&#39;').
             replace(/"/g, '&quot;').
             replace(/</g, '&lt;').
             replace(/>/g, '&gt;');
};

/**
 * @method encodeId
 * @static
 */
dixim.xml.encodeId = function(id) {
  var ret = [];
  var len = id.length;
  var i;

  for (i = 0; i < len; i += 1) {
    ret.push(id.charCodeAt(i).toString(16));
  }
  return ret.join('');
};

/**
 * @method decodeId
 * @static
 */
dixim.xml.decodeId = function(encodedId) {
  var ret = [];
  var len = encodedId.length;
  var n;
  var i;
  var fromCharCode = String.fromCharCode;

  for (i = 0; i < len; i += 2) {
    n = parseInt(encodedId.substring(i, i + 2), 16);
    ret.push(fromCharCode(n));
  }
  return ret.join('');
};

}());