/**
 * @module ctt
 * @submodule confirmation-wizard-allow-transfer-controller
 */
(function() {
var Event = dixim.event.Event;
var WizardPageController = dixim.ctt.WizardPageController;
var ConfirmationWizardPageView = dixim.ctt.ConfirmationWizardPageView;
var ConfirmationWizardPageController = dixim.ctt.ConfirmationWizardPageController;

var ConfirmationWizardAllowTransferController;
var prototype;
var superConstructor;

/**
 * @class ConfirmationWizardAllowTransferController
 * @extends WizardPageController
 * @constructor
 * @param {Object} configs
 */
ConfirmationWizardAllowTransferController = function(configs) {
  WizardPageController.call(this, configs);
};
dixim.inherit(ConfirmationWizardAllowTransferController, WizardPageController);
dixim.ctt.ConfirmationWizardAllowTransferController = ConfirmationWizardAllowTransferController;
prototype = ConfirmationWizardAllowTransferController.prototype;
superConstructor = ConfirmationWizardAllowTransferController.superConstructor;

prototype._createView = function() {
  this._isDownloadMoveIn = this._wizard.getRegistryEntry('isDownloadMoveIn');
  this._view = new ConfirmationWizardPageView({
    isDownloadMoveIn: this._isDownloadMoveIn
  });
};

prototype.start = function() {
  var v;

  if (!!!this._view) {
    this._createView();
  }

  v = this._view;
  v.addEventListener('render', this._didRenderView, this);
  v.addEventListener('cancel', this._didCancel, this);
  v.addEventListener('transfer', this._didClickNext, this);
  v.addEventListener('back', this._didClickBack, this);

  superConstructor.prototype.start.call(this);
};

prototype._didRenderView = function(e) {
  var v = this._view;
  var wizard = this._wizard;
  var target_items;
  var targets_length;

  if (!!!wizard) {
    throw new Error('not pushed into wizard stack');
  }
  target_items = wizard.getRegistryEntry('targetItems');
  targets_length = target_items.length;

  v.setAllowTransferView();
  for (var i = 0; i < targets_length; i += 1) {
    if (target_items[i].writeStatus === 'UNKNOWN') {
      v.addAllowTransferViewList(target_items[i]);
    }
  }
};

prototype._didClickNext = function(e) {
  var v = this._view;
  var w = this._wizard;
  var vc;

  vc = new ConfirmationWizardPageController();
  w.pushViewController(vc);
};

prototype._didClickBack = function(e) {
  var vc;

  if (!!this._wizard) {
    vc = this._wizard.popViewController();
    vc.destroy();
  }
  this._view.setMoveItemView();
};

}());
