/**
 * @module ctt
 * @submodule transfer-history-listing-controller
 */
(function() {
var Event = dixim.event.Event;
var EventTarget = dixim.event.EventTarget;
var TransferHistoryListingView = dixim.ctt.TransferHistoryListingView;

var TransferHistoryListingController;
var prototype;

/**
 * @class TransferHistoryListingController
 * @constructor
 * @param {Object} configs
 */
TransferHistoryListingController = function(configs) {
  EventTarget.call(this);
  this._initialize(configs);
};
dixim.inherit(TransferHistoryListingController, EventTarget);
dixim.ctt.TransferHistoryListingController = TransferHistoryListingController;
prototype = TransferHistoryListingController.prototype;

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 * @param {String|jQuery} configs.containerNode
 */
prototype._initialize = function(configs) {
  this._containerNode = configs.containerNode;
  this._view = new TransferHistoryListingView({containerNode: this._containerNode});
};

/**
 * @method start
 */
prototype.start = function() {
  this._view.show();
};

/**
 * @method stop
 */
prototype.stop = function() {
  this._view.hide();
  
};

/**
 * @method destroy
 */
prototype.destroy = function() {
  this._view.destroy();
};

/**
 * @method update
 * @param {Object[]} records
 */
prototype.update = function(records) {
  this._view.removeAllRows();
  this._view.addRows(records);
};

}());
